
def make_pipeline(functions : list):
    def pipeline(input):
        result = input
        for func in functions:
            result = func(result)
        return result
    return pipeline

def make_column_transformer(func_col_tuple : tuple):
    def column_transformer(df):
        result = df
        for func, cols in func_col_tuple:
            result[cols] = func(result[cols])
        return result
    return column_transformer
